package org.klomp.bpms.bpml.test;

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.net.URL;

import org.exolab.castor.mapping.Mapping;
import org.exolab.castor.mapping.MappingException;
import org.exolab.castor.xml.CastorException;
import org.exolab.castor.xml.Marshaller;
import org.exolab.castor.xml.Unmarshaller;

import org.xml.sax.InputSource;

public class SimpleTest {
    public final static String MAPPING1 = "/lib/mapping/bpml.xml";
    public final static String MAPPING2 = "/lib/mapping/bpml-activities.xml";

    public final static String ROOT = "/";

    public static void main(String args[]) throws Exception {
        Mapping bpmlMapping = new Mapping();
        URL rootURL = SimpleTest.class.getResource(ROOT);
        URL mapping1URL = SimpleTest.class.getResource(MAPPING1);
        bpmlMapping.loadMapping(mapping1URL);
        URL mapping2URL = SimpleTest.class.getResource(MAPPING2);
        bpmlMapping.loadMapping(mapping2URL);

        for (int i = 0; i < args.length; i++) {
            URL sourceURL = new URL(rootURL, args[i]);
            Object dao = readBPML(bpmlMapping, sourceURL);

            System.out.println(args[i] + ": ");
            System.out.println(dao);

            Writer out = new OutputStreamWriter(System.out);
            writeBPML(bpmlMapping, dao, out);
        }
    }

    public static Object readBPML(Mapping bpmlMapping, URL sourceURL)
        throws CastorException, MappingException {
        Unmarshaller unmarshaller = new Unmarshaller(bpmlMapping);

        return unmarshaller.unmarshal(
            new InputSource(sourceURL.toExternalForm()));
    }

    public static void writeBPML(Mapping bpmlMapping, Object dao, Writer out)
        throws CastorException, IOException, MappingException {

        Marshaller marshaller = new Marshaller(out);
        marshaller.setMapping(bpmlMapping);
        //marshaller.setMarshalExtendedType(false);
        marshaller.marshal(dao);
    }

}